import { skippers } from '../config.js'
const manifestData = chrome.runtime.getManifest()
let version_span = document.getElementById('version')
version_span.innerText = manifestData.version

let checkboxes_id_list = skippers.reduce((a, skipper) => {
  a[skipper.service] = a[skipper.service] || []
  skipper.element = null
  a[skipper.service].push(skipper)
  return a
}, Object.create(null))

let styles = ''

for (const [key, value] of Object.entries(checkboxes_id_list)) {
  const container = document.getElementById('services')
  container.insertAdjacentHTML('beforeend', `<p class="service"><strong>${key}</strong></p>`)

  for (let i = 0; i < value.length; i++) {
    container.insertAdjacentHTML('beforeend', `
      <div class="selector">
        <p>${value[i].ui}</p>
        ${value[i].beta ? '<sup><p id="beta">BETA</p></sup>' : ''}
        <label class="switch">
          <input type="checkbox" name="${value[i].service.toLowerCase()}" id="${value[i].name}"></input>
          <span class="slider ${value[i].service.toLowerCase()}"></span>
        </label>
      </div>
    `)

    value[i].element = document.getElementById(value[i].name)

    chrome.storage.local.get(value[i].name, (result) => {
      console.log(result, value[i].element)
      value[i].element.checked = result[value[i].name]
    })

    value[i].element.addEventListener("change", (event) => {
      console.log(event.currentTarget.checked)
      chrome.storage.local.set({ [value[i].name]: event.currentTarget.checked })
    })
  }

  styles += `
    input:checked + .${value[0].service.toLowerCase()} {
      background-color: ${value[0].color};
    }
  `

  container.insertAdjacentHTML('beforeend', '<hr>')
}

const style_sheet = document.createElement("style")
style_sheet.innerText = styles
document.head.appendChild(style_sheet)
